@use '../../../global/styles/styles-variables' as *;
@use './styles/expandable-accordion.variables.scss' as *;

// TODO: Clean this up and move secondary styles to variations etc.

:host {
	@include digi-expandable-accordion--variables;
	display: block;

	.digi-expandable-accordion {
		&::after {
			content: '';
			display: block;
			max-width: var(--digi--paragraph-width--medium);
			border-bottom-width: var(--digi--expandable-accordion--border-bottom-width);
			border-bottom-color: var(--digi--expandable-accordion--border-bottom-color);
			border-bottom-style: solid;
			margin-top: calc(var(--digi--expandable-accordion--border-bottom-width) * -1);
		}

		/*&--expanded-true::after {
			//margin-top: 0;
		}*/

		&--variation-secondary {
			&::after {
				content: none;
			}
		}
	}
}

.digi-expandable-accordion__header {
	display: flex;
	align-items: center;

	.digi-expandable-accordion--variation-primary & {
		max-width: var(--digi--paragraph-width--medium);
		border-bottom-width: var(--digi--expandable-accordion--border-bottom-width);
		border-bottom-color: var(--digi--expandable-accordion--border-bottom-color);
		border-bottom-style: solid;
	}
}

.digi-expandable-accordion__toggle-icon {
	transition: var(--digi--expandable-accordion--header--toggle-icon--transition);

	.digi-expandable-accordion--expanded-true & {
		transform: rotate(-180deg);
	}
}

.digi-expandable-accordion__heading {
	margin: 0;
	flex: 1;
}

.digi-expandable-accordion__button {
	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--expandable-accordion--header--font-size--small);
	font-weight: var(--digi--expandable-accordion--header--font-weight);
	width: 100%;
	display: flex;
	gap: var(--digi--expandable-accordion--icon--margin-right);
	align-items: center;
	text-align: start;
	cursor: pointer;
  border: none;

	@media (min-width: $digi--breakpoint--medium) {
		font-size: var(--digi--expandable-accordion--header--font-size);
	}

	.digi-expandable-accordion--variation-primary & {
		color: var(--digi--color--text--primary);
		background-color: transparent;
		padding: var(--digi--expandable-accordion--content--padding);

		&:hover {
			text-decoration: underline;
		}
	}

	.digi-expandable-accordion--variation-secondary & {
		justify-content: space-between;
		min-height: var(--digi--input-height--large);
		padding: 0 var(--digi--gutter--medium);
		border-radius: var(--digi--border-radius--primary);
		background-color: var(--digi--color--background--input-empty);
		border: 1px solid var(--digi--color--background--tertiary);

		&:focus-visible {
			outline: var(--digi--focus-outline);
			background-color: var(--digi--color--background--tertiary);
		}

		&:hover {
			background-color: var(--digi--color--background--tertiary);
		}
	}

	.digi-expandable-accordion--variation-secondary.digi-expandable-accordion--expanded-true & {
		color: var(--digi--color--text--inverted);
		background-color: var(--digi--color--background--inverted-1);
		border-color: var(--digi--color--background--inverted-1);
		border-block-end: none;
		border-end-end-radius: 0;
		border-end-start-radius: 0;
	}
}

.digi-expandable-accordion__toggle-label {
	display: inline-flex;
	align-items: center;
	gap: var(--digi--gutter--icon);
	font-size: var(--digi--global--typography--font-size--interaction-medium);
	color: var(--digi--color--text--secondary);

	.digi-expandable-accordion--expanded-true & {
		color: currentColor;

		digi-icon {
			--digi--icon--color: currentColor;
		}
	}
}

.digi-expandable-accordion__content {
	overflow-y: hidden;

	.digi-expandable-accordion--expanded-false & {
		height: 0;
	}

	.digi-expandable-accordion--variation-primary & {
		> div {
			padding: var(--digi--expandable-accordion--content--padding);
		}
	}

	.digi-expandable-accordion--variation-primary.digi-expandable-accordion--animation-true & {
		transition: var(--digi--expandable-accordion--content--transition);
	}

	.digi-expandable-accordion--variation-secondary & {
		background: var(--digi--color--background--input-empty);

		> div {
			display: flex;
			flex-direction: column;
		}

		digi-typography {
			display: block;
			padding: var(--digi--container-gutter--small);
		}
	}

	.digi-expandable-accordion--variation-secondary.digi-expandable-accordion--expanded-true & {
		border: 1px solid var(--digi--color--background--inverted-1);
		border-radius: var(--digi--border-radius--primary);
		border-start-end-radius: 0;
		border-start-start-radius: 0;
	}
}

.digi-expandable-accordion__toggle-inside {
	text-align: center;

	--digi--button--color--background--function--hover: var(--digi--color--background--tertiary);
}

@keyframes heightAnim {
	from {
		height: 0%;
	}
	to {
		height: 100%;
	}
}
